#-*- coding:utf-8 -*-

#  Pybik -- A 3 dimensional magic cube game.
#  Copyright (C) 2009  B. Clausius
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License,  or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.


# Ported from GNUbik
# Original filename: drwBlock.c
# Original copyright and license:
#/*
#    The routines which actually draw the blocks of the cube.
#    Copyright (C) 1998,  2003 John Darrington
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License,  or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#*/


#px +DEBUG=False

global __name__
if DEBUG:
    print 'Importing module:', __name__


#TODO Remove this line
from OpenGL import GL as gl
#px-
from OpenGL.GL import *
#px +from OpenGL.GL import glBegin
#px +from OpenGL.GL import glEnd
#px +from OpenGL.GL import glVertex3d
#px+from OpenGL.GL import glVertex3f
#px +from OpenGL.GL import glVertex3fv
#px +from OpenGL.GL import glPushName
#px +from OpenGL.GL import glPopName
#px +from OpenGL.GL import glLoadName
#px +from OpenGL.GL import glColor3f
#px +from OpenGL.GL import glColor3fv
#px +from OpenGL.GL import glRotatef
#px +from OpenGL.GL import glTranslatef
#px +from OpenGL.GL import glTranslated
#px +from OpenGL.GL import glScalef
#px +from OpenGL.GL import glEnable
#px +from OpenGL.GL import glDisable
#px +from OpenGL.GL import glTexEnvi
#px +from OpenGL.GL import glBindTexture
#px +from OpenGL.GL import glTexCoord2f
#px +from OpenGL.GL import glPushMatrix
#px +from OpenGL.GL import glPopMatrix
#px +from OpenGL.GL import glGetFloatv
#px +from OpenGL.GL import glMultMatrixf
#px +from OpenGL.GL import glRasterPos3d

#px+cdef extern from "GL/gl.h":
#px+    cdef void glBegin(int mode)
#px+    cdef void glEnd()
#px+    cdef void glVertex3d(double x, double y, double z)
#px +    cdef void glVertex3f(float x, float y, float z)
#px+    cdef void glVertex3fv(float v[])
#px+    cdef void glPushName(int name)
#px+    cdef void glPopName()
#px+    cdef void glLoadName(int name)
#px+    cdef void glColor3f(float red, float green, float blue)
#px+    cdef void glColor3fv(float *v)
#px+    cdef void glRotatef(float angle, float x, float y, float z)
#px+    cdef void glTranslatef(float x, float y, float z)
#px+    cdef void glTranslated(double x, double y, double z)
#px+    cdef void glScalef(float x, float y, float z)
#px+    cdef void glEnable(int cap)
#px+    cdef void glDisable(int cap)
#px+    cdef void glTexEnvi(int target, int pname, int param)
#px+    cdef void glBindTexture(int target, unsigned int texture)
#px+    cdef void glTexCoord2f(float s, float t)
#px+    cdef void glPushMatrix()
#px+    cdef void glPopMatrix()
#px+    cdef void glGetFloatv(int pname, float *params)
#px+    cdef void glMultMatrixf(float *m)
#px+    cdef void glRasterPos3d(double x, double y, double z)

#px/include "cube_c.pyx"
from cube import MATRIX_DIM, get_face, identify_blocks_3, rotate_slice_3, _cube, _get_block_transform, get_visible_faces

#px+include "opengl_gl.pxi"

#px/DEF MATRIX_DIM = 4
MATRIX_DIM = 4

#import colour_sel
#import txfm


## We use a little bit of glut in debug mode 
#if DEBUG:
#    from OpenGL import GLUT as glut
#
#    def renderString (string):
#        i = 0
#        for i in xrange(len(string)):
#            glut.glutStrokeCharacter (glut.GLUT_STROKE_MONO_ROMAN,  ord(string[i]))



# this macro produces +1 if i is even. -1 if i is odd 
# We use it to g the faces of the block from zero,  to the
# appropriate place 
#cdef int SHIFT(int i):
def SHIFT(i):
    return (i%2) * 2 - 1


#********************
#* Set the normal vector for block/face.
#******

#@debug
#def set_normal_vector(cube_, block, face, v):
#    view = gl.glGetFloatv(GL_MODELVIEW_MATRIX)
#    dest_ = txfm.transform (view, v)
#    cube_.get_face(block, face).normal = dest_
#cdef void set_normal_vector_vj(int block, int face, int vj, int j):
def set_normal_vector_vj(block, face, vj, j):
    #px+cdef Matrix view
    #px/cdef float* dest
    dest = []
    #px/glGetFloatv(GL_MODELVIEW_MATRIX, &view[0][0])
    view = glGetFloatv(GL_MODELVIEW_MATRIX)
    #px+dest = &get_face(block, face).normal[0]
    #px+transform_vj (dest, view, vj, j)
    #px-
    transform_vj (dest, view, vj, j)
    #px-
    get_face(block, face).normal = dest

#cdef void print_vector(Vector v):
def print_vector(v):
    for i_ in xrange(4):
        print '%9.4f' % v[i_],
    print
##cdef print_matrix(Matrix m):
#def print_matrix(m):
#    for i_ in xrange(4):
#        for j_ in xrange(4):
#            print '%9.4f' % m[i_][j_],
#        print


#********************
#* Set the vector for block/face/quadrant to v.
#******/

#def set_quadrant_vector(cube_, block, face, quadrant, v):
#    view = gl.glGetFloatv(GL_MODELVIEW_MATRIX)
#    dest_ = txfm.transform (view, v)
#    cube_.get_face(block, face).quadrants[quadrant] = dest_
#cdef void set_quadrant_vector_vj(int block, int face, int quadrant, int vj, int j):
def set_quadrant_vector_vj(block, face, quadrant, vj, j):
    #px+cdef Matrix view
    #px/cdef float* dest
    dest = []
    #px/glGetFloatv(GL_MODELVIEW_MATRIX, &view[0][0])
    view = glGetFloatv(GL_MODELVIEW_MATRIX)
    #px+dest = &get_face(block, face).quadrants[quadrant][0]
    #px+transform_vj (dest, view, vj, j)
    #px-
    transform_vj (dest, view, vj, j)
    #px-
    get_face(block, face).quadrants[quadrant] = dest


#def transform(M, x):
#    q = [sum(M[j][i] * x[j] for j in xrange(MATRIX_DIM))
#         for i in xrange(MATRIX_DIM)]
#    return q
#cdef void transform_vj(float *r, Matrix M, float vj, int j):
def transform_vj(r, M, vj, j):
    #px-
    assert len(r) == 0
    #px+cdef int i
    #px/for 0 <= i < MATRIX_DIM:
    for i in xrange(MATRIX_DIM):
        #px/r[i] = M[j][i] * vj
        r.append(M[j][i] * vj)


def start_animate(move_data_):
    _cube.move_slice = move_data_.slice
    _cube.move_dir = move_data_.dir
    _cube.move_axis = move_data_.axis
    _cube.animation_angle = 0.0
    _cube.animation_running = identify_blocks_3(_cube.move_slice, _cube.move_axis)

#px/def step_animate(float increment):
def step_animate(increment):
    _cube.animation_angle = _cube.animation_angle - increment
    return abs(_cube.animation_angle) < 90.0

def end_animate(move_data_):
    turn_qty = 0
    # -90 degrees equals +270 degrees
    if move_data_.dir == 1:
        turn_qty = 1
    elif move_data_.dir == 0:
        turn_qty = 3
    
    rotate_slice_3 (turn_qty, _cube.move_axis)
    
    _cube.animation_running = 0

#px+ctypedef void face_func_t (int, float*, int, int)
#px/cdef face_func_t* face_func
face_func = None # draw_face or pick_face

def draw_cube():
    _draw_cube (0)

def pick_cube():
    _draw_cube (1)

# render the cube
#cdef void _draw_cube (int picking):
def _draw_cube (picking):
    #px+cdef int i, axis_
    #px+cdef float angle, unity
    #px+cdef float* M
    
    global face_func
    if picking:
        face_func = pick_face
    else:
        face_func = draw_face
    #drawCube_debug()
    
    #px/for 0 <= i < _cube.number_blocks:
    for i in xrange(_cube.number_blocks):
        glPushMatrix ()
        # Find out if this block is one of those currently being
        # turned.  If so,  j will be < turning_block_qty
        if _cube.animation_running:
            if _cube.blocks[i].in_motion:
                # Blocks which are in motion,  need to be animated.
                # so we rotate them according to however much the
                # animation angle is
                angle = _cube.animation_angle
                
                if _cube.move_dir:
                    unity = 1
                else:
                    unity = -1

                axis_ = _cube.move_axis
                if axis_ >= 3:
                    axis_ = axis_ - 3
    
                if axis_ == 0:
                    glRotatef (angle,  unity, 0, 0)
                elif axis_ == 1:
                    glRotatef (angle, 0,  unity, 0)
                elif axis_ == 2:
                    glRotatef (angle, 0, 0,  unity)
            
        
        # place the block in its current position and
        # orientation
        M = _get_block_transform (i)
        glPushMatrix()
        glMultMatrixf(M)

        # and draw the block
        draw_block (0,  i)
        glPopMatrix ()
        
        glPopMatrix ()


# render the block pointed to by attrib.
# if highlight is true,  then the outline is white,
# otherwise it is black 
#@debug
#px/cdef void draw_block (int highlight, int block_id):
def draw_block (highlight, block_id):
    #cdef int i, mask
    
    # Load the name of this block 
    glLoadName (block_id)
    # Start a new name level ( for the face of the block) 
    glPushName (-1)
    # Rasterise only the exterior faces,  to speed things up 
    glEnable (GL_CULL_FACE)

    #px/for 0 <= i < 6:
    for i in xrange(6):
        glPushMatrix ()
        if i <= 1:
            glTranslated (0, 0,  SHIFT (i))
        elif i <= 3:
            glTranslated (0,  SHIFT (i), 0)
            glRotatef (-90, 1, 0, 0)
        else:
            glTranslated (SHIFT (i), 0, 0)
            glRotatef (90, 0, 1, 0)

        # make sure all  the sides are faced with their visible
        # surface pointing to the outside!!  
        if not (i % 2):
            glRotatef (180, 1, 0, 0)

        # draw the face,  iff it is visible 
        mask = 0x01 << i
        if get_visible_faces (block_id) & mask:
            glLoadName (i)
            if highlight:
                face_func (i, _color_white, block_id, True)
            else:
                face_func (i, _color_black, block_id, True)
        elif _cube.animation_running:
            glLoadName (100)
            if highlight:
                face_func (i, _color_white, block_id, False)
            else:
                face_func (i, _color_black, block_id, False)

        glPopMatrix()

    glPopName ()


    #showBlock (block_id)

# render the face,  with a specified fill,  and outline colour 
#@debug
#px/cdef void draw_face (int face, float *col_outline, int block_id, int withlabel):
def draw_face (face, col_outline, block_id, withlabel):
    #px+cdef float image_segment_size
    #px+cdef int xpos, ypos
    
    # lratio is the proportion of a face's linear dimension,  which is
    # coloured. That is,  covered by a sticky label 
    #px/DEF lratio = 0.9
    lratio = 0.9

    # First Draw the surface of the cube,  that is the plastic material
    # he thing is constructed from 
    glColor3fv (col_outline)

    #v = txfm.Vector()
    #p1 = [0, 0, 0]
    #p2 = [0, 0, 1]
    #txfm.vector_from_points (p2, p1, v)
    #v = [0, 0,-1, 0]
    #set_normal_vector (block_id, face, v)
    set_normal_vector_vj (block_id, face, -1, 2)

    glPushName (0)

    glBegin (GL_POLYGON)
    glVertex3d (-1,  1, 0)
    glVertex3d (-1, -1, 0)
    glVertex3d ( 1, -1, 0)
    glVertex3d ( 1,  1, 0)
    glEnd ()

    glPopName()


    if not (face % 2):
        glRotatef (180, 0, 0, 1)

    if withlabel:
        # Now do the colours  (ie the little sticky labels)
        glColor3fv (face_rendering[face].color)
        glTranslatef (0, 0, 0.01)


        glScalef (lratio,  lratio,  lratio)


        if face_rendering[face].texName == -1:
            glDisable (GL_TEXTURE_2D)
        else:
            glEnable (GL_TEXTURE_2D)
            if face_rendering[face].type_ == IMAGED:
                glTexEnvi (GL_TEXTURE_ENV,  GL_TEXTURE_ENV_MODE,  GL_DECAL)
            else:
                glTexEnvi (GL_TEXTURE_ENV,  GL_TEXTURE_ENV_MODE,  GL_MODULATE)

            glBindTexture (GL_TEXTURE_2D,  face_rendering[face].texName)


        glBegin (GL_POLYGON)
        xpos = 0
        ypos = 0

        if face_rendering[face].type_ == IMAGED and face_rendering[face].distr == _MOSAIC:
            #print 'IMAGED and MOSAIC'
            image_segment_size = 1.0 / _cube.dimension
            if face & 6 == 0: # 0 or 1
                xpos = block_id % _cube.dimension
                ypos = block_id % _cube.dimension2 / _cube.dimension
            elif face & 6 == 2: # 2 or 3
                xpos = block_id % _cube.dimension
                ypos = block_id / _cube.dimension2
            elif face & 6 == 4: # 4 or 5
                xpos = block_id / _cube.dimension2
                ypos = block_id % _cube.dimension2 / _cube.dimension

            # Invert positions as necessary 
            if face == 0:
                xpos = _cube.dimension - xpos - 1
                ypos = _cube.dimension - ypos - 1
            elif face == 1:
                ypos = _cube.dimension - ypos - 1
            elif face == 5:
                xpos = _cube.dimension - xpos - 1
                ypos = _cube.dimension - ypos - 1
            elif face == 4:
                ypos = _cube.dimension - ypos - 1
            elif face == 2:
                xpos = _cube.dimension - xpos - 1
        else: # TILED 
            #print 'TILED'
            #xpos = ypos = 0
            image_segment_size = 1.0

        glTexCoord2f (image_segment_size*xpos,  image_segment_size*(ypos+1))
        glVertex3d (-1.0, -1.0, 0.0)

        glTexCoord2f (image_segment_size*(xpos+1),  image_segment_size*(ypos+1))
        glVertex3d (1.0, -1.0, 0.0)

        glTexCoord2f (image_segment_size*(xpos+1),  image_segment_size*(ypos))
        glVertex3d (1.0, 1.0, 0.0)

        glTexCoord2f (image_segment_size*(xpos),  image_segment_size*(ypos))
        glVertex3d (-1.0, 1.0, 0.0)

        glEnd ()

        glDisable (GL_TEXTURE_2D)
        
    #draw_face_debug (face, col_outline, block_id)

#@debug
#px/cdef void pick_face (int face, float *col_outline, int block_id, int withlabel):
def pick_face(face, col_outline, block_id, withlabel):
    # lratio is the proportion of a face's linear dimension,  which is
    # coloured. That is,  covered by a sticky label 
    #lratio = 0.9

    # First Draw the surface of the cube,  that is the plastic material
    # he thing is constructed from 
    #gl.glColor3fv (colors[col_outline])


    # the dead zone is the space on the square,  which pointing to with
    # the mouse will not change the selection.  This gives a bit of
    # histeresis,  and makes it easier to use. 
    deadZone = 0.0#0.02
    limit1 = 1 - deadZone
    limit2 = 1 - 2*deadZone


    # This polygon is drawn as four quadrants,  thus:
    #    _______
    #   |\     /|
    #   | \   / |
    #   |  \ /  |
    #   |   \   |
    #   |  / \  |
    #   | /   \ |
    #   |/____ \|
    #
    # The reason for this is to provide support for an enhanced selection
    # mechanism which can detect which edge of the face is being pointed to.

    #v = txfm.Vector()
    #p1 = [0, 0, 0]
    #p2 = [0, 0, 1]
    #v = [0, 0, -1, 0]
    #txfm.vector_from_points (p2, p1, v)
    #set_normal_vector (block_id, face, v)
    set_normal_vector_vj (block_id, face, -1, 2)

    glPushName (0)

    #p1[0] = -deadZone;   p1[1] = 0.0;  p1[2] = 0.0
    #p2[0] = -limit1;     p2[1] = 0.0;  p2[2] = 0.0

    gl.glBegin (GL_POLYGON)
    #gl.glVertex3fv (p1)
    glVertex3d (-deadZone,   0.0, 0.0)
    glVertex3d (-limit1,  limit2, 0.0)
    glVertex3d (-limit1, -limit2, 0.0)
    gl.glEnd ()

    #txfm.vector_from_points (p2, p1, v)
    #v = [1,0,0,0]
    #set_quadrant_vector (block_id, face, 0, v)
    set_quadrant_vector_vj (block_id, face, 0, 1, 0)


    glLoadName (1)

    #p1[0] = 0.0;  p1[1] = -deadZone;  p1[2] = 0.0
    #p2[0] = 0.0;  p2[1] = limit1;     p2[2] = 0.0

    gl.glBegin (GL_POLYGON)
    #gl.glVertex3fv (p1)
    glVertex3d ( 0,   -deadZone, 0)
    glVertex3d ( limit2, limit1, 0)
    glVertex3d (-limit2, limit1, 0)
    gl.glEnd ()

    #txfm.vector_from_points (p2, p1, v)
    #v = [0,-1,0,0]
    #set_quadrant_vector (block_id, face, 1, v)
    set_quadrant_vector_vj (block_id, face, 1, -1, 1)


    glLoadName (2)

    #p1[0] = deadZone;  p1[1] = 0.0;  p1[2] = 0.0
    #p2[0] = limit1;    p2[1] = 0.0;  p2[2] = 0.0

    gl.glBegin (GL_POLYGON)
    #gl.glVertex3fv (p1)
    glVertex3d (deadZone, 0.0,   0.0)
    glVertex3d (limit1, -limit2, 0.0)
    glVertex3d (limit1,  limit2, 0.0)
    gl.glEnd ()

    #txfm.vector_from_points (p2, p1, v)
    #v = [-1,0,0,0]
    #set_quadrant_vector (block_id, face, 2, v)
    set_quadrant_vector_vj (block_id, face, 2, -1, 0)


    glLoadName (3)

    #p1[0] = 0.0;  p1[1] = deadZone;  p1[2] = 0.0
    #p2[0] = 0.0;  p2[1] = -limit1;   p2[2] = 0.0

    gl.glBegin (GL_POLYGON)
    glVertex3d (0, -deadZone, 0.0)
    #gl.glVertex3fv (p1)
    glVertex3d (0.0,    deadZone, 0.0)
    glVertex3d (-limit2, -limit1, 0.0)
    glVertex3d (limit2,  -limit1, 0.0)
    gl.glEnd ()

    glPopName()

    #txfm.vector_from_points (p2, p1, v)
    #v = [0,1,0,0]
    #set_quadrant_vector (block_id, face, 3, v)
    set_quadrant_vector_vj (block_id, face, 3, 1, 1)
    
    if not (face % 2):
        gl.glRotatef (180, 0, 0, 1)


#@debug_only(DEBUG)
def drawCube_debug():
    offset = 1.6 * _cube.dimension

    # Show the directions of the axes
    glColor3f (1, 1, 1)

    # X axis
    glPushMatrix ()
    glTranslatef (-offset, -offset, 0)
    glBegin (GL_LINES)
    glVertex3f (0, 0, 0)
    glVertex3f (2*_cube.dimension, 0, 0)
    glEnd ()


    glRasterPos3d (offset*1.1, 0, 0)
#    glut.glutBitmapCharacter (glut.GLUT_BITMAP_9_BY_15, ord('0'))

    glPopMatrix ()

    # Y axis
    glPushMatrix ()
    glTranslatef (-offset, -offset, 0)
    glBegin (GL_LINES)
    glVertex3f (0, 0, 0)
    glVertex3f (0, 2*_cube.dimension, 0)
    glEnd ()

    glRasterPos3d (0.1*offset,  offset, 0)
#    glut.glutBitmapCharacter (glut.GLUT_BITMAP_9_BY_15, '1')

    glPopMatrix ()

    # Z axis
    glPushMatrix ()
    glTranslatef (-offset, -offset, 0)

    glBegin (GL_LINES)
    glVertex3f (0, 0, 0)
    glVertex3f (0, 0, 2*_cube.dimension)
    glEnd ()

    glRasterPos3d (0.1*offset, 0,  offset)
#    glut.glutBitmapCharacter (glut.GLUT_BITMAP_9_BY_15, '2')

    glPopMatrix ()

#@debug_only(DEBUG)
def draw_face_debug (face, col_outline, block_id):
    #char str[4]

    # render the block number 
    glPushMatrix ()
    glColor3f (0, 0, 0)

    glTranslatef (-1,  -0.8, 0.1)
    glScalef (0.01, 0.01, 0.01)

#    renderString (("%d" % block_id)[:4])
    glPopMatrix ()

    # render the face number,  a little bit smaller
    # so we can see what's what. 
    glPushMatrix ()
    glTranslatef (+0.5,  +0.4, 0.1)
    glScalef (0.005, 0.005, 0.005)
#    renderString (("%d" % face)[:4])
    glPopMatrix ()


#cdef enum:
if True:
    _TILED = 0
    _MOSAIC = 1

#cdef enum:
if True:
    UNDEFINED = 0
    COLORED = 1
    IMAGED = 2


colors = [
            [1.0, 0.0, 0.0],
            [0.0, 1.0, 0.0],
            [0.0, 0.0, 1.0],
            [0.0, 1.0, 1.0],
            [1.0, 0.0, 1.0],
            [1.0, 1.0, 0.0],
        ]
color_black = [0.1, 0.1, 0.1]
color_white = [1.0, 1.0, 1.0]
#px/cdef float _color_black[3]
_color_black = color_black
#px/cdef float _color_white[3]
_color_white = color_white


#cdef struct _FaceRendering:
class _FaceRendering:
    #px-
    def __init__(self, _i):
        #px/float color[3]
        self.color = colors[_i]
        #px/int type_
        self.type_ = 0     # UNDEFINED, COLORED, IMAGED
        #px/unsigned int texName
        self.texName = 0  # uint
        #px/int distr
        self.distr = 0    # TILED, MOSAIC

#cdef _FaceRendering face_rendering[6]
face_rendering = []

def init_face_rendering():
    #px+for 0 <= i < 6:
    #px+    for 0 <= j < 3:
    #px+        face_rendering[i].color[j] = colors[i][j]
    #px+for 0 <= j < 3:
    #px+    _color_black[j] = color_black[j]
    #px+for 0 <= j < 3:
    #px+    _color_white[j] = color_white[j]
    #px-
    for __i in xrange(6):
        #px-
        face_rendering.append(_FaceRendering(__i))
init_face_rendering()


def face_rendering_set(swatch, red=-1,green=-1,blue=-1, facetype=UNDEFINED, texname=None, distr=-1):
    if red >= 0:    face_rendering[swatch].color[0] = red
    if green >= 0:  face_rendering[swatch].color[1] = green
    if blue >= 0:   face_rendering[swatch].color[2] = blue
    
    if facetype > 0: face_rendering[swatch].type_ = facetype
    
    if texname is not None:
        face_rendering[swatch].texName = texname
    
    if distr >= 0:  face_rendering[swatch].distr = distr


